testpower.c File Reference
`#include <stdio.h>`
`#include "SDL.h"`
Include dependency graph for testpower.c:

Go to the source code of this file.

## Functions

static void | report_power (void)
int | main (int argc, char *argv[])

## Function Documentation

int main | ( | int | argc,
|  | char * | argv[]
| ) |  |

Definition at line 64 of file testpower.c.

References report_power(), SDL_GetError, SDL_Init, SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO, SDL_LogError, SDL_LogSetPriority, and SDL_Quit.

{
/* Enable standard application logging */
SDL_LogSetPriority(SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO);
if (SDL_Init(0) == -1) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "SDL_Init() failed: %s\n", SDL_GetError());
return 1;
}
report_power();
SDL_Quit();
return 0;
}
SDL_GetError
#define SDL_GetError
Definition: SDL_dynapi_overrides.h:119
SDL_LogError
#define SDL_LogError
Definition: SDL_dynapi_overrides.h:42
report_power
static void report_power(void)
Definition: testpower.c:18
SDL_Quit
#define SDL_Quit
Definition: SDL_dynapi_overrides.h:64
SDL_LOG_PRIORITY_INFO
Definition: SDL_log.h:106
SDL_LogSetPriority
#define SDL_LogSetPriority
Definition: SDL_dynapi_overrides.h:242
SDL_Init
#define SDL_Init
Definition: SDL_dynapi_overrides.h:60
SDL_LOG_CATEGORY_APPLICATION
Definition: SDL_log.h:66

static void report_power | ( | void |  | ) |

static

Definition at line 18 of file testpower.c.

References NULL, SDL_GetPowerInfo, SDL_Log, SDL_POWERSTATE_CHARGED, SDL_POWERSTATE_CHARGING, SDL_POWERSTATE_NO_BATTERY, SDL_POWERSTATE_ON_BATTERY, SDL_POWERSTATE_UNKNOWN, and state.

Referenced by main().

{
int seconds, percent;
const SDL_PowerState state = SDL_GetPowerInfo(&seconds, &percent);
char *statestr = NULL;
SDL_Log("SDL-reported power info...\n");
switch (state) {
case SDL_POWERSTATE_UNKNOWN:
statestr = "Unknown";
break;
case SDL_POWERSTATE_ON_BATTERY:
statestr = "On battery";
break;
case SDL_POWERSTATE_NO_BATTERY:
statestr = "No battery";
break;
case SDL_POWERSTATE_CHARGING:
statestr = "Charging";
break;
case SDL_POWERSTATE_CHARGED:
statestr = "Charged";
break;
default:
statestr = "!!API ERROR!!";
break;
}
SDL_Log("State: %s\n", statestr);
if (percent == -1) {
SDL_Log("Percent left: unknown\n");
} else {
SDL_Log("Percent left: %d%%\n", percent);
}
if (seconds == -1) {
SDL_Log("Time left: unknown\n");
} else {
SDL_Log("Time left: %d minutes, %d seconds\n", (int) (seconds / 60),
(int) (seconds % 60));
}
}
state
struct xkb_state * state
Definition: SDL_waylandsym.h:94
SDL_POWERSTATE_UNKNOWN
Definition: SDL_power.h:44
SDL_POWERSTATE_CHARGED
Definition: SDL_power.h:48
SDL_POWERSTATE_NO_BATTERY
Definition: SDL_power.h:46
SDL_Log
#define SDL_Log
Definition: SDL_dynapi_overrides.h:37
SDL_GetPowerInfo
#define SDL_GetPowerInfo
Definition: SDL_dynapi_overrides.h:298
SDL_POWERSTATE_CHARGING
Definition: SDL_power.h:47
NULL
#define NULL
Definition: begin_code.h:143
SDL_POWERSTATE_ON_BATTERY
Definition: SDL_power.h:45
SDL_PowerState
SDL_PowerState
The basic state for the system&#39;s power supply.
Definition: SDL_power.h:42